Unit ZP37R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure ZP37R(NP :Integer; var A :Array of Real; M :Integer;
                var B :Array of Real; R :Real; var S :Real);

implementation

procedure ZP37R(NP :Integer; var A :Array of Real; M :Integer;
                var B :Array of Real; R :Real; var S :Real);
var
I,J,JK,K,L,N :Integer;
T,E,X :Real;
label
_1,_2,_3,_4,_5,_6,_7,_8;
begin
T := R;
N := NP;
I := 0;
_1:
I := I+1;
if ( A[I-1] > 0.0 ) 
 then goto _2;
if ( I <= N ) 
 then goto _1;
B[0] := 0.0;
if ( M > 1 ) 
 then goto _3;
goto _8;
_2:
K := I-1;
E := T*K;
B[0] := Power(A[K+0],T);
if ( M <= 1 ) 
 then goto _8;
if ( N > 0 ) 
 then goto _5;
_3:
for I:=2 to M do
 begin
_4:
  B[I-1] := 0.0;
 end;
goto _8;
_5:
for I:=2 to M do
 begin
  JK := I;
  if ( JK > N+1 ) 
   then JK := N+1;
  X := 0.0;
  for J:=2 to JK do
   begin
    L := I-J+1;
_6:
    X := X+A[K+J-1]*B[L-1]*((J-1)*T-(I-J));
   end;
_7:
  B[I-1] := X/(A[K+0]*(I-1));
 end;
S := E;
_8:
end;

end.
